package info.textgrid.middleware;

import info.textgrid.middleware.oaipmh.ListSetsType;
import info.textgrid.middleware.oaipmh.SetType;


import java.util.ArrayList;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Set;

import org.elasticsearch.action.get.GetRequestBuilder;
import org.elasticsearch.action.get.GetResponse;
import org.elasticsearch.action.search.SearchRequestBuilder;
import org.elasticsearch.action.search.SearchResponse;
import org.elasticsearch.index.query.QueryBuilders;
import org.elasticsearch.index.query.QueryStringQueryBuilder;
import org.elasticsearch.search.SearchHit;

public class SetDeliverer {

	private OAI_ESClient	oaiEsClient;

	public SetDeliverer(OAI_ESClient oaiEsClient) {
		this.oaiEsClient = oaiEsClient;
	}

	private Set<String>	identifier			= new LinkedHashSet<String>();
    private String formatField;
    private String formatToFilter;
    private String identifierField;
    private String repositoryObjectURIPrefix;
    private String specField;
    private String specFieldPrefix;
    private Set<String> project	= new LinkedHashSet<String>();
    private Set<String> projectID	= new LinkedHashSet<String>();
    private boolean textgrid= true;

	public ListSetsType setListBuilder() {
	
		ListSetsType setList = new ListSetsType();

		QueryStringQueryBuilder aggQuery = QueryBuilders.queryString("*");

		SearchRequestBuilder request = this.oaiEsClient.getOaiESClient()
				.prepareSearch(this.oaiEsClient.getEsIndex())
				.setTypes(this.oaiEsClient.getEsType()).setQuery(aggQuery)
				.addField(formatField)
				.addField(identifierField)
				.addField("project.value")
				.addField("project.id")
				.setSize(100000); 
		
		SearchResponse getRecordListItems = request.execute().actionGet();

		for (SearchHit hit : getRecordListItems.getHits().getHits()) {
			System.out.println("testitest: " + textgrid);
			if(hit.getFields().get(formatField) != null && hit.getFields().get(formatField).value().equals(formatToFilter)) {
				System.out.println("testitest1");
				this.identifier.add(hit.getFields().get(identifierField).values().get(0).toString());
				
				if(textgrid==true){
					System.out.println("testitest2");
					String projectName = hit.getFields().get("project.value").values().get(0).toString();
					String projectID = hit.getFields().get("project.id").values().get(0).toString();
					String projectSetSpec = projectName.concat(":").concat(projectID);
					this.project.add(projectSetSpec);
					//this.project.add(hit.getFields().get("project.value").values().get(0).toString());
					//this.projectID.add(hit.getFields().get("project.id").values().get(0).toString());
				}
			}
			

		}
		
		if(textgrid==true){
		
			for(String projectSetSpec : this.project){
				SetType set = new SetType();
				String[] projectValues = projectSetSpec.split(":");
				String projectName = projectValues[0];
				String projectID = projectValues[1];
				
				set.setSetName(projectName);				
				set.setSetSpec("project:" + projectID);				
				setList.getSet().add(set);
			}
		}
		else{
		
		for (String identifierSetSpec : this.identifier) {
			String id = identifierSetSpec;
			System.out.println("The id is: " + id);
			if (identifierSetSpec.startsWith(repositoryObjectURIPrefix)) {
				id = identifierSetSpec.substring(repositoryObjectURIPrefix.length());
			}

			GetRequestBuilder collectionNameById = this.oaiEsClient
					.getOaiESClient().prepareGet()
					.setIndex(this.oaiEsClient.getEsIndex())
					.setType(this.oaiEsClient.getEsType())
					.setFields(specField).setId(id); 
			
			GetResponse setSpec = collectionNameById.execute().actionGet();

			
				String setName = "";
				if(setSpec.isExists()){
					if (setSpec != null && setSpec.getField(specField) != null) {
						setName = setSpec.getField(specField).getValue().toString();
					}
				}else{
					System.out.println(id + "does not exist");
				}
				SetType set = new SetType();

				set.setSetName(setName);
				set.setSetSpec(specFieldPrefix + ":" + id);
				setList.getSet().add(set);
			
				
		}
		}
		identifier.clear();
		return setList;

	}
	
	public String getFormatField() {
		return formatField;
	}
	public void setFormatField(String formatField) {
		this.formatField = formatField;
	}

	public String getFormatToFilter() {
		return formatToFilter;
	}

	public void setFormatToFilter(String formatToFilter) {
		this.formatToFilter = formatToFilter;
	}

	public String getIdentifierField() {
		return identifierField;
	}

	public void setIdentifierField(String identifierField) {
		this.identifierField = identifierField;
	}

	public String getRepositoryObjectURIPrefix() {
		return repositoryObjectURIPrefix;
	}

	public void setRepositoryObjectURIPrefix(String repositoryObjectURIPrefix) {
		this.repositoryObjectURIPrefix = repositoryObjectURIPrefix;
	}

	public String getSpecField() {
		return specField;
	}

	public void setSpecField(String titleField) {
		this.specField = titleField;
	}

	public String getSpecFieldPrefix() {
		return specFieldPrefix;
	}

	public void setSpecFieldPrefix(String specFieldPrefix) {
		this.specFieldPrefix = specFieldPrefix;
	}
}
